using CarCenterContracts.BindingModels;
using CarCenterContracts.BusinessLogicsContracts;
using CarCenterContracts.SearchModels;
using CarCenterContracts.StoragesContracts;
using CarCenterContracts.ViewModels;
using Microsoft.Extensions.Logging;

namespace CarCenterBusinessLogic.BusinessLogics
{
    public class SaleLogic : ISaleLogic
    {
        private readonly ILogger _logger;
        private readonly ISaleStorage _SaleStorage;
        private readonly IManagerLogic _managerLogic;

        public SaleLogic(ILogger<SaleLogic> logger, ISaleStorage SaleStorage, IManagerLogic ManagerLogic)
        {
            _logger = logger;
            _SaleStorage = SaleStorage;
            _managerLogic = ManagerLogic;
        }

        public bool Create(SaleBindingModel model)
        {
            CheckModel(model);

            var result = _SaleStorage.Insert(model);

            if (result == null)
            {
                _logger.LogWarning("Insert operation failed");
                return false;
            }

            return true;
        }

        public bool Delete(SaleBindingModel model)
        {
            CheckModel(model, false);

            _logger.LogInformation("Delete. Id:{Id}", model.Id);

            var result = _SaleStorage.Delete(model);

            if (result == null)
            {
                _logger.LogWarning("Delete operation failed");
                return false;
            }

            return true;
        }

        public SaleViewModel? ReadElement(SaleSearchModel model)
        {
            if (model == null)
            {
                throw new ArgumentNullException(nameof(model));
            }

            _logger.LogInformation("ReadElement. SaleFIO:{SaleFIO}.Id:{Id}", model.SaleDate, model.Id);

            var element = _SaleStorage.GetElement(model);

            if (element == null)
            {
                _logger.LogWarning("ReadElement element not found");
                return null;
            }

            _logger.LogInformation("ReadElement find. Id:{Id}", element.Id);

            return element;
        }

        public List<SaleViewModel>? ReadList(SaleSearchModel? model)
        {
            _logger.LogInformation("ReadList. SaleFIO:{SaleFIO}.Id:{ Id}", model?.SaleDate, model?.Id);

            var list = model == null ? _SaleStorage.GetFullList() : _SaleStorage.GetFilteredList(model);

            if (list == null)
            {
                _logger.LogWarning("ReadList return null list");
                return null;
            }

            _logger.LogInformation("ReadList. Count:{Count}", list.Count);

            return list;
        }

        public bool Update(SaleBindingModel model)
        {
            CheckModel(model);

            if (_SaleStorage.Update(model) == null)
            {
                _logger.LogWarning("Update operation failed");
                return false;
            }

            return true;
        }
        private void CheckModel(SaleBindingModel model, bool withParams = true)
        {
            if (model == null)
            {
                throw new ArgumentNullException(nameof(model));
            }

            if (!withParams)
            {
                return;
            }


            if (string.IsNullOrEmpty(model.SalePrice))
            {
                throw new ArgumentNullException("Не указана цена продажи", nameof(model.SalePrice));
            }

            _logger.LogInformation("Sale. SaleFIO:{SaleFIO}.SalePrice:{ SalePrice}. Id: { Id}", model.SaleDate, model.SalePrice, model.Id);
        }
    }
}
